#include <core> 
#include <console> 
#include <string> 
#include <admin> 
#include <adminlib>
#include <plugin>

#define TERROR 1
#define CT 2

new STRING_VERSION[MAX_DATA_LENGTH] = "0.2";

public plugin_info(HLOldName, HLNewName, UserIndex){
	new Name[MAX_NAME_LENGTH];
	new UserID,WONID,Team,Dead;
	new sAuthID[MAX_AUTHID_LENGTH];
	if(UserIndex>0){
		playerinfo(UserIndex,Name,MAX_NAME_LENGTH,UserID,WONID,Team,Dead,sAuthID);
	}
	else{
		return PLUGIN_CONTINUE;
	}
	new sHLOldName[MAX_NAME_LENGTH];
	new sHLNewName[MAX_NAME_LENGTH];
	convert_string(HLOldName,sHLOldName,MAX_NAME_LENGTH);
	convert_string(HLNewName,sHLNewName,MAX_NAME_LENGTH);
	if(!streq(sHLOldName,sHLNewName)){
		return PLUGIN_CONTINUE;
	}
	new TBot=0;
	new CTBot=0;
	checkbot(TBot,CTBot);
	kickbot(TBot,CTBot);
	
	return PLUGIN_CONTINUE;
}

checkbot(&TBot,&CTBot){
	new Name[MAX_NAME_LENGTH];
	new UserID,WONID,Team,Dead;
	new sAuthID[MAX_AUTHID_LENGTH];
	new i;
	new maxplayers=maxplayercount();

	for(i=1;i<=maxplayers;i++){
		if(playerinfo(i,Name,MAX_NAME_LENGTH,UserID,WONID,Team,Dead,sAuthID) && streq(sAuthID,"BOT")){
			if(Team==1){
				TBot++;
			}
			else{
				CTBot++;
			}
		}
	}

	return PLUGIN_CONTINUE;
}

kickbot(TBot,CTBot){
	new iTplayers=getteamcount(TERROR);
	new iCTplayers=getteamcount(CT);
	new iBots;

	if(get_vaultnumdata("BK_BM_BOTS",iBots) && iBots<playercount() && TBot+CTBot!=0){
		if(iTplayers>=iCTplayers && TBot>0){
			removebot(TERROR);
		}
		else{
			removebot(CT);
		}
	}

	return PLUGIN_CONTINUE;
}

removebot(Team){
	new sPrefix[MAX_DATA_LENGTH];
	new sKick[MAX_DATA_LENGTH];

	get_vaultdata("BK_BM_PREFIX",sPrefix,MAX_DATA_LENGTH);
	if(Team==TERROR){
		get_vaultdata("BK_BM_KICKT",sKick,MAX_DATA_LENGTH);
	}
	if(Team==CT){
		get_vaultdata("BK_BM_KICKCT",sKick,MAX_DATA_LENGTH);
	}
	snprintf(sKick,MAX_DATA_LENGTH,"%s %s",sPrefix,sKick);
	exec(sKick);
		
	return PLUGIN_CONTINUE;
}

public plugin_disconnect(HLUserName, UserIndex){
	new TBot=0;
	new CTBot=0;

	checkbot(TBot,CTBot);
	startbot(TBot,CTBot);

	return PLUGIN_CONTINUE;
}

startbot(TBot,CTBot){
	new iBots;

	if(get_vaultnumdata("BK_BM_BOTS",iBots) && iBots>TBot+CTBot && iBots>=playercount()){
		set_timer("addbot",1,iBots-playercount());
	}

	return PLUGIN_CONTINUE;
}

public addbot(Timer,Repeat,HLParam){
	new iTplayers=getteamcount(TERROR);
	new iCTplayers=getteamcount(CT);
	new iBots;
	new sPrefix[MAX_DATA_LENGTH];
	new sAdd[MAX_DATA_LENGTH];

	if(get_vaultnumdata("BK_BM_BOTS",iBots) && iBots<=playercount()){
		return PLUGIN_CONTINUE;
	}
		
	get_vaultdata("BK_BM_PREFIX",sPrefix,MAX_DATA_LENGTH);
	if(iTplayers<=iCTplayers){
		get_vaultdata("BK_BM_ADDT",sAdd,MAX_DATA_LENGTH);
	}
	else{
		get_vaultdata("BK_BM_ADDCT",sAdd,MAX_DATA_LENGTH);
	}
	snprintf(sAdd,MAX_DATA_LENGTH,"%s %s",sPrefix,sAdd);
	exec(sAdd);
		
	return PLUGIN_CONTINUE;
}

public addbotsmc(Timer,Repeat,HLParam) {
	new TBot=0;
	new CTBot=0;

	checkbot(TBot,CTBot);
	startbot(TBot,CTBot);

	return PLUGIN_CONTINUE;
}

public plugin_init() {
	/* Plugin Registrierung */
	plugin_registerinfo("BK Botmanager","Adds and removes bots automatically.",STRING_VERSION);
	set_timer("addbotsmc",15,0);

 	return PLUGIN_CONTINUE; 
}
